import type { Logger } from './interface.js';
export interface WebRTCDataChannelOptions {
    onMessage: (event: MessageEvent<Uint8Array>) => void;
    onOpen: () => void;
    onClose: () => void;
    onError: (err: Error) => void;
    log: Logger;
}
export declare class WebRTCDataChannel {
    label: string;
    private readonly channel;
    private readonly closingInterval;
    private open;
    private readonly log;
    constructor(channel: RTCDataChannel, opts: WebRTCDataChannelOptions);
    send(data: Uint8Array): Promise<void>;
    close(): void;
    get bufferedAmount(): number;
}
//# sourceMappingURL=channel.d.ts.map