/// <reference types="node" />
import { EventEmitter } from 'events';
import { Pushable } from 'it-pushable';
import { WebRTCDataChannel } from './channel.js';
import type { WRTC } from './interface.js';
import type { Duplex } from 'it-stream-types';
export interface Logger {
    (...opts: any[]): void;
    error: (...opts: any[]) => void;
}
export interface WebRTCPeerOptions {
    id?: string;
    wrtc?: WRTC;
    peerConnectionConfig?: RTCConfiguration;
}
export declare class WebRTCPeer extends EventEmitter implements Duplex<Uint8Array> {
    id: string;
    source: Pushable<Uint8Array>;
    sink: (source: AsyncIterable<Uint8Array> | Iterable<Uint8Array>) => Promise<void>;
    closed: boolean;
    protected wrtc: WRTC;
    protected peerConnection: RTCPeerConnection;
    protected channel?: WebRTCDataChannel;
    protected log: Logger;
    private readonly connected;
    constructor(opts: WebRTCPeerOptions & {
        logPrefix: string;
    });
    protected handleDataChannelEvent(event: {
        channel?: RTCDataChannel;
    }): void;
    close(err?: Error): Promise<void>;
}
//# sourceMappingURL=peer.d.ts.map